%% (b)-Teil
function A_5_4
close all;
% Erstellen von A, b1, b2 und c:
A1 = zeros(4,4); A1(2,1)=1/2; A1(3,2)=1/2; A1(4,3)=1;
b1=[1/6;2/6;2/6;1/6;0]; c1 = [0;1/2;1/2;1];
A2 = zeros(5,5); A2(1:4,1:4)=A1; A2(5,:)=[b1'];
b2 = [1/6;2/6;2/6;0;1/6]; c = [c1;1];

% rechte Seite f
f=@(t,Y)[1+Y(1,:).^2.*Y(2,:)-4*Y(1,:); 3*Y(1,:)-Y(1,:).^2.*Y(2,:)];

% Startwerte:
y0=[1.01;3];
x0=0;
% Endzeitpunkt
T=20;

% Vorgaben:
h0=1; tol=10^(-5); tau=0.9; p=3;
% Verfahren durchführen
[xi,hat_yi] = RKV_expl_embedded(A2,b2,b1,c,f,y0,x0,T,h0,tol,tau,p);

% 1. Teilplot
subplot(2,1,1);
% Plot der Graphen:
plot(xi,hat_yi(1,:),xi,hat_yi(2,:));
legend('y1','y2');
title('Approximation des Graphen von y_1 und y_2');
xlabel('Zeit ti');
ylabel('y_i');

% 2. Teilplot
subplot(2,1,2);
% Schrittweiten
hi = xi(2:end) - xi(1:end-1);
% Plot der Schrittweiten:
plot(xi(1:end-1),hi,'+'); 
title('Plot der Schritweiten hi gegen ti');
xlabel('Schritt i');
ylabel('hi');
grid minor % zur besseren Übersicht ein Gitter einzeichnen


%% (a)-Teil
function [xi,hat_yi] = RKV_expl_embedded(A,b1,b2,c,f,y0,x0,T,h0,tol,tau,p)

% Initialisierung mit der Startzeit (wird nach und nach um die Zeiten x_{i+1} = x_{i} + hi ergänzt)
xi=x0;
s=max(size(b1)); % Anzahl der Stufen des RKVs
d=max(size(y0)); % Dimesion des AWPs
eta=zeros(d,s); % eta_j's als Spalten der Matrix eta
% Initialisierung der Lösungsmatrix, die nach und nach um eine Spalte mit dem aktuellen hat_yi ergänzt wird:
hat_yi=zeros(d,1);
hat_yi(:,1)=y0; % Startwert

% Da hier die Anzahl der Schritte nicht von Begin an bekannt ist,
% wird eine while-Schleife benutzt:
i=1; % mit "i" werden die Schritte gezaehlt 
h=h0; % Startschrittweite
while(xi(i)<T)
    %-------------------------------------------------------
    % Berechnung der eta_j's:
    for j=1:s 
        sum=0;
        for l=1:j-1
            sum=sum+A(j,l)*f(xi(i)+c(l)*h,eta(:,l));
        end
        eta(:,j)=hat_yi(:,i)+h*sum;
    end
    %--------------------------------------------------------
    
    %--------------------------------------------------------
    % doppelte Endauswertung der RKV's
    % d.h. y_i->y_{i+1} und \hat y_i->\hat y_{i+1}
    hat_sum=0;
    sum=0;
    for k=1:s
        sum=sum+b1(k)*f(xi(i)+c(k)*h,eta(:,k));
        hat_sum=hat_sum+b2(k)*f(xi(i)+c(k)*h,eta(:,k));
    end
    yi=hat_yi(:,i)+h*sum;
    hat_yi_tmp=hat_yi(:,i)+h*hat_sum; % es ist noch nicht klar, ob der Schritt akzeptiert wird, daher hat_yi_tmp, statt hat_yi erweitern
    %--------------------------------------------------------
    
    %--------------------------------------------------------
    % Berechnung des Fehlerschaetzers:
    delta=norm(yi-hat_yi_tmp);
    
    if delta>0 % Berechnug der neuen Schrittweite nur wenn Fehler nicht Null war
        h=tau*((tol/delta)^(1/(p+1)))*h;
    else % Ansonsten ist die neue schrittweite die Startschrittweite. Dazu:
                  % wenn delta = 0 ist, ist mein Schritt also "perfekt"
                  % gewesen und das neue h kann größer gewählt werden.
                  % Natürlich aber auch nicht unendlich groß! Anstatt in
                  % diesem Fall h auf ein fixes h0 zu setzen könnte man
                  % auch h = const*h setzen, das aktuelle h also um einen
                  % maximalen faktor vergrößern. Andere Varianten sind auch
                  % denkbar.
        h=h0;
    end
    
    if delta<tol % Falls der Schritt akzeptiert wird
        i=i+1; % starte neuen Schritt
        xi=[xi xi(end)+h]; % Anhangen des nächsten Zeitpunkts
        hat_yi=[hat_yi hat_yi_tmp]; % Anhängen von \hat y_{i+1}
    end % Falls die if-Schleife nicht triggered, wird der Schritt mit der oben angepassten Schrittweite wiederholt.
end
